Index: cpukit/libfs/src/dosfs/msdos_dir.c
===================================================================
--- cpukit/libfs/src/dosfs/msdos_dir.c	(revision 8bed60314e383fe461c03236857b9ba369beecd4)
+++ cpukit/libfs/src/dosfs/msdos_dir.c	(revision d2e0bb36e34f1fe45641f26b8b8d6ef615963854)
@@ -9,4 +9,7 @@
  *  Copyright (C) 2001 OKTET Ltd., St.-Petersburg, Russia
  *  Author: Eugeny S. Mints <Eugeny.Mints@oktet.ru>
+ *
+ *  Modifications to support UTF-8 in the file system are
+ *  Copyright (c) 2013 embedded brains GmbH.
  *
  *  The license and distribution terms for this file may be
@@ -34,72 +37,5 @@
 #include "msdos.h"
 
-/*  msdos_format_dirent_with_dot --
- *      This routine convert a (short) MSDOS filename as present on disk
- *      (fixed 8+3 characters, filled with blanks, without separator dot)
- *      to a "normal" format, with between 0 and 8 name chars,
- *      a separating dot and up to 3 extension characters
- *   Rules to work:
- *      - copy any (0-8) "name" part characters that are non-blank
- *      - if an extension exists, append a dot
- *      - copy any (0-3) non-blank extension characters
- *      - append a '\0' (dont count it for the rturn code
- *
- * PARAMETERS:
- *     dst: pointer to destination char array (must be big enough)
- *     src: pointer to source characters
- *
- *
- * RETURNS:
- *     the number of bytes (without trailing '\0'(written to destination
- */
-static ssize_t
-msdos_format_dirent_with_dot(char *dst,const char *src)
-{
-  ssize_t len;
-  int i;
-  const char *src_tmp;
-
-  /*
-   * find last non-blank character of base name
-   */
-  for ((i       =       MSDOS_SHORT_BASE_LEN  ,
-	src_tmp = src + MSDOS_SHORT_BASE_LEN-1);
-       ((i > 0) &&
-	(*src_tmp == ' '));
-       i--,src_tmp--)
-    {};
-  /*
-   * copy base name to destination
-   */
-  src_tmp = src;
-  len = i;
-  while (i-- > 0) {
-    *dst++ = tolower((unsigned char)(*src_tmp++));
-  }
-  /*
-   * find last non-blank character of extension
-   */
-  for ((i       =                            MSDOS_SHORT_EXT_LEN  ,
-	src_tmp = src + MSDOS_SHORT_BASE_LEN+MSDOS_SHORT_EXT_LEN-1);
-       ((i > 0) &&
-	(*src_tmp == ' '));
-       i--,src_tmp--)
-    {};
-  /*
-   * extension is not empty
-   */
-  if (i > 0) {
-    *dst++ = '.'; /* append dot */
-    len += i + 1; /* extension + dot */
-    src_tmp = src + MSDOS_SHORT_BASE_LEN;
-    while (i-- > 0) {
-      *dst++ = tolower((unsigned char)(*src_tmp++));
-      len++;
-    }
-  }
-  *dst = '\0'; /* terminate string */
-
-  return len;
-}
+
 
 /*  msdos_dir_read --
@@ -129,9 +65,16 @@
 {
     int                rc = RC_OK;
+    int                eno = 0;
     rtems_status_code  sc = RTEMS_SUCCESSFUL;
     msdos_fs_info_t   *fs_info = iop->pathinfo.mt_entry->fs_info;
+    rtems_dosfs_convert_control *converter = fs_info->converter;
+    const rtems_dosfs_convert_handler *convert_handler = converter->handler;
     fat_file_fd_t     *fat_fd = iop->pathinfo.node_access;
     fat_file_fd_t     *tmp_fat_fd = NULL;
     struct dirent      tmp_dirent;
+    size_t             tmp_lfn_len = 0;
+    uint16_t          *lfn_buf = converter->buffer.data;
+    char              *sfn_buf = converter->buffer.data;
+    const size_t       buf_size = converter->buffer.size;
     uint32_t           start = 0;
     ssize_t            ret = 0;
@@ -143,4 +86,6 @@
     uint8_t            lfn_checksum = 0;
     int                lfn_entries = 0;
+    size_t             string_size = sizeof(tmp_dirent.d_name);
+    bool               is_first_entry;
 
     /*
@@ -168,5 +113,5 @@
         rtems_set_errno_and_return_minus_one(EIO);
 
-    while (count > 0)
+    while (count > 0 && cmpltd >= 0)
     {
         /*
@@ -184,5 +129,5 @@
         }
 
-        for (i = 0; i < ret; i += MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE)
+        for (i = 0; i < ret && cmpltd >= 0; i += MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE)
         {
             char* entry = (char*) fs_info->cl_buf + i;
@@ -214,7 +159,5 @@
                 MSDOS_ATTR_LFN)
             {
-                int   o;
-                char* p;
-                int   q;
+                int offset_lfn;
 
                 /*
@@ -223,4 +166,5 @@
                 if (lfn_start == FAT_FILE_SHORT_NAME)
                 {
+                    is_first_entry = true;
                     /*
                      * The first entry must have the last long entry flag set.
@@ -242,7 +186,10 @@
                     lfn_entries = (*MSDOS_DIR_ENTRY_TYPE(entry) &
                                    MSDOS_LAST_LONG_ENTRY_MASK);
+                    tmp_lfn_len = 0;
                     lfn_checksum = *MSDOS_DIR_LFN_CHECKSUM(entry);
                     memset (tmp_dirent.d_name, 0, sizeof(tmp_dirent.d_name));
                 }
+                else
+                    is_first_entry = false;
 
                 /*
@@ -263,5 +210,7 @@
                  * Extract the file name into the directory entry. The data is
                  * stored in UNICODE characters (16bit). No translation is
-                 * currently supported.
+                 * done for the possibly partial entry.
+                 * Once all entries have been assembled to a UTF-16 file name,
+                 * this file name will get converted to UTF-8.
                  *
                  * The DOS maximum length is 255 characters without the
@@ -271,30 +220,11 @@
 
                 lfn_entries--;
-                p = entry + 1;
-                o = lfn_entries * MSDOS_LFN_LEN_PER_ENTRY;
-
-                for (q = 0; q < MSDOS_LFN_LEN_PER_ENTRY; q++)
-                {
-                    if (o >= (sizeof(tmp_dirent.d_name) - 1))
-                        break;
-
-                    tmp_dirent.d_name[o++] = *p;
-
-                    if (*p == '\0')
-                        break;
-
-                    switch (q)
-                    {
-                        case 4:
-                            p += 5;
-                            break;
-                        case 10:
-                            p += 4;
-                            break;
-                        default:
-                            p += 2;
-                            break;
-                    }
-                }
+                offset_lfn = lfn_entries * MSDOS_LFN_LEN_PER_ENTRY;
+                tmp_lfn_len += msdos_get_utf16_string_from_long_entry (
+                  entry,
+                  &lfn_buf[offset_lfn],
+                  buf_size - offset_lfn,
+                  is_first_entry
+                );
             }
             else
@@ -345,7 +275,8 @@
 
                 /*
-                 * If a long file name check if the correct number of
-                 * entries have been found and if the checksum is correct.
-                 * If not return the short file name.
+                 * If a long file name check if the correct number of entries
+                 * have been found and if the checksum is correct and if it is
+                 * convertable to utf8 string.  If not return the short file
+                 * name.
                  */
                 if (lfn_start != FAT_FILE_SHORT_NAME)
@@ -360,4 +291,18 @@
                     if (lfn_entries || (lfn_checksum != cs))
                         lfn_start = FAT_FILE_SHORT_NAME;
+
+                    eno = (*convert_handler->utf16_to_utf8) (
+                        converter,
+                        lfn_buf,
+                        tmp_lfn_len,
+                        (uint8_t*)(&tmp_dirent.d_name[0]),
+                        &string_size);
+                    if (eno == 0) {
+                      tmp_dirent.d_namlen                    = string_size;
+                      tmp_dirent.d_name[tmp_dirent.d_namlen] = '\0';
+                    }
+                    else {
+                        lfn_start = FAT_FILE_SHORT_NAME;
+                    }
                 }
 
@@ -369,23 +314,35 @@
                      */
                     tmp_dirent.d_namlen = msdos_format_dirent_with_dot(
-                        tmp_dirent.d_name, entry); /* src text */
-                }
-                else
-                {
-                    tmp_dirent.d_namlen = strlen(tmp_dirent.d_name);
-                }
-
-                memcpy(buffer + cmpltd, &tmp_dirent, sizeof(struct dirent));
-
-                iop->offset = iop->offset + sizeof(struct dirent);
-                cmpltd += (sizeof(struct dirent));
-                count -= (sizeof(struct dirent));
-
-                /* inode number extracted, close fat-file */
-                rc = fat_file_close(&fs_info->fat, tmp_fat_fd);
-                if (rc != RC_OK)
-                {
-                    rtems_semaphore_release(fs_info->vol_sema);
-                    return rc;
+                        sfn_buf, entry); /* src text */
+                    eno = (*convert_handler->codepage_to_utf8) (
+                        converter,
+                        sfn_buf,
+                        tmp_dirent.d_namlen,
+                        (uint8_t*)(&tmp_dirent.d_name[0]),
+                        &string_size);
+                    if ( 0 == eno ) {
+                      tmp_dirent.d_namlen                    = string_size;
+                      tmp_dirent.d_name[tmp_dirent.d_namlen] = '\0';
+                    }
+                    else {
+                        cmpltd = -1;
+                        errno  = eno;
+                    }
+                }
+
+                if ( cmpltd >= 0 ) {
+                    memcpy(buffer + cmpltd, &tmp_dirent, sizeof(struct dirent));
+
+                    iop->offset = iop->offset + sizeof(struct dirent);
+                    cmpltd += (sizeof(struct dirent));
+                    count -= (sizeof(struct dirent));
+
+                    /* inode number extracted, close fat-file */
+                    rc = fat_file_close(&fs_info->fat, tmp_fat_fd);
+                    if (rc != RC_OK)
+                    {
+                        rtems_semaphore_release(fs_info->vol_sema);
+                        return rc;
+                    }
                 }
             }
Index: cpukit/libfs/src/dosfs/msdos_fsunmount.c
===================================================================
--- cpukit/libfs/src/dosfs/msdos_fsunmount.c	(revision 8bed60314e383fe461c03236857b9ba369beecd4)
+++ cpukit/libfs/src/dosfs/msdos_fsunmount.c	(revision d2e0bb36e34f1fe45641f26b8b8d6ef615963854)
@@ -48,6 +48,7 @@
     msdos_fs_info_t *fs_info = temp_mt_entry->fs_info;
     fat_file_fd_t   *fat_fd = temp_mt_entry->mt_fs_root->location.node_access;
+    rtems_dosfs_convert_control *converter = fs_info->converter;
 
-    /* close fat-file which correspondes to root directory */
+    /* close fat-file which corresponds to root directory */
     fat_file_close(&fs_info->fat, fat_fd);
 
@@ -55,4 +56,5 @@
 
     rtems_semaphore_delete(fs_info->vol_sema);
+    (*converter->handler->destroy)( converter );
     free(fs_info->cl_buf);
     free(temp_mt_entry->fs_info);
Index: cpukit/libfs/src/dosfs/msdos_init.c
===================================================================
--- cpukit/libfs/src/dosfs/msdos_init.c	(revision 8bed60314e383fe461c03236857b9ba369beecd4)
+++ cpukit/libfs/src/dosfs/msdos_init.c	(revision d2e0bb36e34f1fe45641f26b8b8d6ef615963854)
@@ -12,4 +12,7 @@
  *  Modifications to support reference counting in the file system are
  *  Copyright (c) 2012 embedded brains GmbH.
+ *
+ *  Modifications to support UTF-8 in the file system are
+ *  Copyright (c) 2013 embedded brains GmbH.
  *
  *  The license and distribution terms for this file may be
@@ -90,13 +93,31 @@
  *
  */
-int rtems_dosfs_initialize(rtems_filesystem_mount_table_entry_t *mt_entry,
-                           const void                           *data)
+int rtems_dosfs_initialize(
+  rtems_filesystem_mount_table_entry_t *mt_entry,
+  const void                           *data
+)
 {
-    int rc;
+    int                                rc = 0;
+    const rtems_dosfs_mount_options   *mount_options = data;
+    rtems_dosfs_convert_control       *converter;
 
-    rc = msdos_initialize_support(mt_entry,
-                                  &msdos_ops,
-                                  &msdos_file_handlers,
-                                  &msdos_dir_handlers);
+
+    if (mount_options == NULL || mount_options->converter == NULL) {
+        converter = rtems_dosfs_create_default_converter();
+    } else {
+        converter = mount_options->converter;
+    }
+
+    if (converter != NULL) {
+        rc = msdos_initialize_support(mt_entry,
+                                      &msdos_ops,
+                                      &msdos_file_handlers,
+                                      &msdos_dir_handlers,
+                                      converter);
+    } else {
+        errno = ENOMEM;
+        rc = -1;
+    }
+
     return rc;
 }
Index: cpukit/libfs/src/dosfs/msdos_initsupp.c
===================================================================
--- cpukit/libfs/src/dosfs/msdos_initsupp.c	(revision 8bed60314e383fe461c03236857b9ba369beecd4)
+++ cpukit/libfs/src/dosfs/msdos_initsupp.c	(revision d2e0bb36e34f1fe45641f26b8b8d6ef615963854)
@@ -53,5 +53,6 @@
     const rtems_filesystem_operations_table *op_table,
     const rtems_filesystem_file_handlers_r  *file_handlers,
-    const rtems_filesystem_file_handlers_r  *directory_handlers
+    const rtems_filesystem_file_handlers_r  *directory_handlers,
+    rtems_dosfs_convert_control             *converter
     )
 {
@@ -68,4 +69,6 @@
 
     temp_mt_entry->fs_info = fs_info;
+
+    fs_info->converter = converter;
 
     rc = fat_init_volume_info(&fs_info->fat, temp_mt_entry->dev);
